/*************************************************************/
/* Copyright (C) 2015 OSS Nokalva, Inc.  All rights reserved.*/
/*************************************************************/

/* THIS FILE IS PROPRIETARY MATERIAL OF OSS NOKALVA, INC.
 * AND MAY BE USED ONLY BY DIRECT LICENSEES OF OSS NOKALVA, INC.
 * THIS FILE MAY NOT BE DISTRIBUTED. */

/* Generated for: Testing Technologies IST GmbH, Berlin, Germany - License 11335 on Linux */
/* Abstract syntax: dsrc_reg_d */
/* ASN.1 Java project: org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.Libitsmapspat_asn1 */
/* Created: Mon Feb  9 16:50:07 2015 */
/* ASN.1 Compiler for Java version: 5.1.0.2 */
/* ASN.1 compiler options and file names specified:
 * -output org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1
 * -nolistingfile -nomodlistingfile -constraints -nouserconstraints -valuerefs
 * -debug -nopedantic -noinformatorymessages -uper -root -keepnames
 * -norelaySafe -noparamtypesuperclass -jiaapi -autoencdec -messageFormat emacs
 * /tmp/TTthree-2015.02.09.16.49.37.896/oss6894826343771225846gen/LibItsMapSpat_asn1.gen
 * asn/ITS-Container.asn asn/REG_D.asn asn/MAP_SPAT_ETSI.asn
 * asn/DSRC_REG_D.asn
 */


package org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc;

import com.oss.asn1.*;
import com.oss.metadata.*;

/**
 * Define the ASN1 Type MapData from ASN1 Module DSRC.
 * @see Sequence
 */

public class MapData extends Sequence {
    
    /**
     * The default constructor.
     */
    public MapData()
    {
    }
    
    /**
     * Construct with AbstractData components.
     */
    public MapData(DSRCmsgID2 msgID, DSRCmsgSubID msgSubID, 
		    MsgCount msgIssueRevision, LayerType layerType, 
		    LayerID layerID, IntersectionGeometryList intersections, 
		    RoadSegmentList roadSegments, 
		    DataParameters dataParameters, 
		    RestrictionClassList restrictionList, 
		    RegionalMapData regional, MsgCRC crc)
    {
	setMsgID(msgID);
	setMsgSubID(msgSubID);
	setMsgIssueRevision(msgIssueRevision);
	setLayerType(layerType);
	setLayerID(layerID);
	setIntersections(intersections);
	setRoadSegments(roadSegments);
	setDataParameters(dataParameters);
	setRestrictionList(restrictionList);
	setRegional(regional);
	setCrc(crc);
    }
    
    /**
     * Construct with required components.
     */
    public MapData(DSRCmsgID2 msgID, MsgCount msgIssueRevision)
    {
	setMsgID(msgID);
	setMsgIssueRevision(msgIssueRevision);
    }
    
    public void initComponents()
    {
	mComponents[0] = new DSRCmsgID2();
	mComponents[1] = new DSRCmsgSubID();
	mComponents[2] = new MsgCount();
	mComponents[3] = LayerType.none;
	mComponents[4] = new LayerID();
	mComponents[5] = new IntersectionGeometryList();
	mComponents[6] = new RoadSegmentList();
	mComponents[7] = new DataParameters();
	mComponents[8] = new RestrictionClassList();
	mComponents[9] = new RegionalMapData();
	mComponents[10] = new MsgCRC();
    }
    
    // Instance initializer
    {
	mComponents = new AbstractData[11];
    }
    
    // Method to create a specific component instance
    public AbstractData createInstance(int index)
    {
	switch (index) {
	    case 0:
		return new DSRCmsgID2();
	    case 1:
		return new DSRCmsgSubID();
	    case 2:
		return new MsgCount();
	    case 3:
		return LayerType.none;
	    case 4:
		return new LayerID();
	    case 5:
		return new IntersectionGeometryList();
	    case 6:
		return new RoadSegmentList();
	    case 7:
		return new DataParameters();
	    case 8:
		return new RestrictionClassList();
	    case 9:
		return new RegionalMapData();
	    case 10:
		return new MsgCRC();
	    default:
		throw new InternalError("AbstractCollection.createInstance()");
	}
	
    }
    
    
    // Methods for field "msgID"
    public DSRCmsgID2 getMsgID()
    {
	return (DSRCmsgID2)mComponents[0];
    }
    
    public void setMsgID(DSRCmsgID2 msgID)
    {
	mComponents[0] = msgID;
    }
    
    
    // Methods for field "msgSubID"
    public DSRCmsgSubID getMsgSubID()
    {
	return (DSRCmsgSubID)mComponents[1];
    }
    
    public void setMsgSubID(DSRCmsgSubID msgSubID)
    {
	mComponents[1] = msgSubID;
    }
    
    public boolean hasMsgSubID()
    {
	return componentIsPresent(1);
    }
    
    public void deleteMsgSubID()
    {
	setComponentAbsent(1);
    }
    
    
    // Methods for field "msgIssueRevision"
    public MsgCount getMsgIssueRevision()
    {
	return (MsgCount)mComponents[2];
    }
    
    public void setMsgIssueRevision(MsgCount msgIssueRevision)
    {
	mComponents[2] = msgIssueRevision;
    }
    
    
    // Methods for field "layerType"
    public LayerType getLayerType()
    {
	return (LayerType)mComponents[3];
    }
    
    public void setLayerType(LayerType layerType)
    {
	mComponents[3] = layerType;
    }
    
    public boolean hasLayerType()
    {
	return componentIsPresent(3);
    }
    
    public void deleteLayerType()
    {
	setComponentAbsent(3);
    }
    
    
    // Methods for field "layerID"
    public LayerID getLayerID()
    {
	return (LayerID)mComponents[4];
    }
    
    public void setLayerID(LayerID layerID)
    {
	mComponents[4] = layerID;
    }
    
    public boolean hasLayerID()
    {
	return componentIsPresent(4);
    }
    
    public void deleteLayerID()
    {
	setComponentAbsent(4);
    }
    
    
    // Methods for field "intersections"
    public IntersectionGeometryList getIntersections()
    {
	return (IntersectionGeometryList)mComponents[5];
    }
    
    public void setIntersections(IntersectionGeometryList intersections)
    {
	mComponents[5] = intersections;
    }
    
    public boolean hasIntersections()
    {
	return componentIsPresent(5);
    }
    
    public void deleteIntersections()
    {
	setComponentAbsent(5);
    }
    
    
    // Methods for field "roadSegments"
    public RoadSegmentList getRoadSegments()
    {
	return (RoadSegmentList)mComponents[6];
    }
    
    public void setRoadSegments(RoadSegmentList roadSegments)
    {
	mComponents[6] = roadSegments;
    }
    
    public boolean hasRoadSegments()
    {
	return componentIsPresent(6);
    }
    
    public void deleteRoadSegments()
    {
	setComponentAbsent(6);
    }
    
    
    // Methods for field "dataParameters"
    public DataParameters getDataParameters()
    {
	return (DataParameters)mComponents[7];
    }
    
    public void setDataParameters(DataParameters dataParameters)
    {
	mComponents[7] = dataParameters;
    }
    
    public boolean hasDataParameters()
    {
	return componentIsPresent(7);
    }
    
    public void deleteDataParameters()
    {
	setComponentAbsent(7);
    }
    
    
    // Methods for field "restrictionList"
    public RestrictionClassList getRestrictionList()
    {
	return (RestrictionClassList)mComponents[8];
    }
    
    public void setRestrictionList(RestrictionClassList restrictionList)
    {
	mComponents[8] = restrictionList;
    }
    
    public boolean hasRestrictionList()
    {
	return componentIsPresent(8);
    }
    
    public void deleteRestrictionList()
    {
	setComponentAbsent(8);
    }
    
    
    // Methods for field "regional"
    public RegionalMapData getRegional()
    {
	return (RegionalMapData)mComponents[9];
    }
    
    public void setRegional(RegionalMapData regional)
    {
	mComponents[9] = regional;
    }
    
    public boolean hasRegional()
    {
	return componentIsPresent(9);
    }
    
    public void deleteRegional()
    {
	setComponentAbsent(9);
    }
    
    
    // Methods for field "crc"
    public MsgCRC getCrc()
    {
	return (MsgCRC)mComponents[10];
    }
    
    public void setCrc(MsgCRC crc)
    {
	mComponents[10] = crc;
    }
    
    public boolean hasCrc()
    {
	return componentIsPresent(10);
    }
    
    public void deleteCrc()
    {
	setComponentAbsent(10);
    }
    
    
    /**
     * Initialize the type descriptor.
     */
    private static final SequenceInfo c_typeinfo = new SequenceInfo (
	new Tags (
	    new short[] {
		0x0010
	    }
	),
	new QName (
	    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
	    "MapData"
	),
	new QName (
	    "DSRC",
	    "MapData"
	),
	12318,
	null,
	new Fields (
	    new SequenceFieldInfo[] {
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8000
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"DSRCmsgID2"
			    ),
			    new QName (
				"DSRC",
				"DSRCmsgID2"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new DSRCmsgID2(0), 
				    new DSRCmsgID2(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    null
			)
		    ),
		    "msgID",
		    0,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8001
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"DSRCmsgSubID"
			    ),
			    new QName (
				"DSRC",
				"DSRCmsgSubID"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new DSRCmsgSubID(0), 
				    new DSRCmsgSubID(255),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(255)
			    ),
			    null
			)
		    ),
		    "msgSubID",
		    1,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8002
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"MsgCount"
			    ),
			    new QName (
				"DSRC",
				"MsgCount"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new MsgCount(0), 
				    new MsgCount(127),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(127)
			    ),
			    null
			)
		    ),
		    "msgIssueRevision",
		    2,
		    2,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new EnumeratedInfo (
			    new Tags (
				new short[] {
				    (short)0x8003
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"LayerType"
			    ),
			    new QName (
				"DSRC",
				"LayerType"
			    ),
			    12318,
			    null,
			    new MemberList (
				new MemberListElement[] {
				    new MemberListElement (
					"none",
					0
				    ),
				    new MemberListElement (
					"mixedContent",
					1
				    ),
				    new MemberListElement (
					"generalMapData",
					2
				    ),
				    new MemberListElement (
					"intersectionData",
					3
				    ),
				    new MemberListElement (
					"curveData",
					4
				    ),
				    new MemberListElement (
					"roadwaySectionData",
					5
				    ),
				    new MemberListElement (
					"parkingAreaData",
					6
				    ),
				    new MemberListElement (
					"sharedLaneData",
					7
				    )
				}
			    ),
			    0,
			    LayerType.none
			)
		    ),
		    "layerType",
		    3,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new IntegerInfo (
			    new Tags (
				new short[] {
				    (short)0x8004
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"LayerID"
			    ),
			    new QName (
				"DSRC",
				"LayerID"
			    ),
			    12314,
			    new ValueRangeConstraint (
				new AbstractBounds(
				    new LayerID(0), 
				    new LayerID(100),
				    0
				)
			    ),
			    new Bounds (
				new java.lang.Long(0),
				new java.lang.Long(100)
			    ),
			    null
			)
		    ),
		    "layerID",
		    4,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ContainerInfo (
			    new Tags (
				new short[] {
				    (short)0x8005
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"IntersectionGeometryList"
			    ),
			    new QName (
				"DSRC",
				"IntersectionGeometryList"
			    ),
			    12314,
			    new SizeConstraint (
				new ValueRangeConstraint (
				    new AbstractBounds(
					new com.oss.asn1.INTEGER(1), 
					new com.oss.asn1.INTEGER(32),
					0
				    )
				)
			    ),
			    new Bounds (
				new java.lang.Long(1),
				new java.lang.Long(32)
			    ),
			    new TypeInfoRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				    "IntersectionGeometry"
				)
			    )
			)
		    ),
		    "intersections",
		    5,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ContainerInfo (
			    new Tags (
				new short[] {
				    (short)0x8006
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"RoadSegmentList"
			    ),
			    new QName (
				"DSRC",
				"RoadSegmentList"
			    ),
			    12314,
			    new SizeConstraint (
				new ValueRangeConstraint (
				    new AbstractBounds(
					new com.oss.asn1.INTEGER(1), 
					new com.oss.asn1.INTEGER(32),
					0
				    )
				)
			    ),
			    new Bounds (
				new java.lang.Long(1),
				new java.lang.Long(32)
			    ),
			    new TypeInfoRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				    "RoadSegment"
				)
			    )
			)
		    ),
		    "roadSegments",
		    6,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8007
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"DataParameters"
			    ),
			    new QName (
				"DSRC",
				"DataParameters"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				    "DataParameters"
				)
			    ),
			    0,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				    "DataParameters"
				)
			    ),
			    0
			)
		    ),
		    "dataParameters",
		    7,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new ContainerInfo (
			    new Tags (
				new short[] {
				    (short)0x8008
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"RestrictionClassList"
			    ),
			    new QName (
				"DSRC",
				"RestrictionClassList"
			    ),
			    12314,
			    new SizeConstraint (
				new ValueRangeConstraint (
				    new AbstractBounds(
					new com.oss.asn1.INTEGER(1), 
					new com.oss.asn1.INTEGER(254),
					0
				    )
				)
			    ),
			    new Bounds (
				new java.lang.Long(1),
				new java.lang.Long(254)
			    ),
			    new TypeInfoRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				    "RestrictionClassAssignment"
				)
			    )
			)
		    ),
		    "restrictionList",
		    8,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new SequenceInfo (
			    new Tags (
				new short[] {
				    (short)0x8009
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"RegionalMapData"
			    ),
			    new QName (
				"DSRC",
				"RegionalMapData"
			    ),
			    12318,
			    null,
			    new FieldsRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				    "RegionalMapData"
				)
			    ),
			    1,
			    new TagDecodersRef (
				new QName (
				    "org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				    "RegionalMapData"
				)
			    ),
			    0
			)
		    ),
		    "regional",
		    9,
		    3,
		    null
		),
		new SequenceFieldInfo (
		    new TypeInfoRef (
			new VectorInfo (
			    new Tags (
				new short[] {
				    (short)0x800a
				}
			    ),
			    new QName (
				"org.etsi.its.codec.tool.testingtech.LibItsMapSpat_asn1.dsrc",
				"MsgCRC"
			    ),
			    new QName (
				"DSRC",
				"MsgCRC"
			    ),
			    12314,
			    new SizeConstraint (
				new SingleValueConstraint (
				    new com.oss.asn1.INTEGER(2)
				)
			    ),
			    new Bounds (
				new java.lang.Long(2),
				new java.lang.Long(2)
			    )
			)
		    ),
		    "crc",
		    10,
		    3,
		    null
		)
	    }
	),
	0,
	new TagDecoders (
	    new TagDecoder[] {
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8000, 0)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8001, 1),
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8002, 2)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8003, 3),
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6),
			new TagDecoderElement((short)0x8007, 7),
			new TagDecoderElement((short)0x8008, 8),
			new TagDecoderElement((short)0x8009, 9),
			new TagDecoderElement((short)0x800a, 10)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8004, 4),
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6),
			new TagDecoderElement((short)0x8007, 7),
			new TagDecoderElement((short)0x8008, 8),
			new TagDecoderElement((short)0x8009, 9),
			new TagDecoderElement((short)0x800a, 10)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8005, 5),
			new TagDecoderElement((short)0x8006, 6),
			new TagDecoderElement((short)0x8007, 7),
			new TagDecoderElement((short)0x8008, 8),
			new TagDecoderElement((short)0x8009, 9),
			new TagDecoderElement((short)0x800a, 10)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8006, 6),
			new TagDecoderElement((short)0x8007, 7),
			new TagDecoderElement((short)0x8008, 8),
			new TagDecoderElement((short)0x8009, 9),
			new TagDecoderElement((short)0x800a, 10)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8007, 7),
			new TagDecoderElement((short)0x8008, 8),
			new TagDecoderElement((short)0x8009, 9),
			new TagDecoderElement((short)0x800a, 10)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8008, 8),
			new TagDecoderElement((short)0x8009, 9),
			new TagDecoderElement((short)0x800a, 10)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x8009, 9),
			new TagDecoderElement((short)0x800a, 10)
		    }
		),
		new TagDecoder (
		    new TagDecoderElement[] {
			new TagDecoderElement((short)0x800a, 10)
		    }
		)
	    }
	),
	0
    );
    
    /**
     * Get the type descriptor (TypeInfo) of 'this' MapData object.
     */
    public TypeInfo getTypeInfo()
    {
	return c_typeinfo;
    }
    
    /**
     * Get the static type descriptor (TypeInfo) of 'this' MapData object.
     */
    public static TypeInfo getStaticTypeInfo()
    {
	return c_typeinfo;
    }
    
} // End class definition for MapData
